diff --git a/src/backend/access/transam/fdwxact_launcher.c b/src/backend/access/transam/fdwxact_launcher.c
new file mode 100644
index 0000000000..59f061773c
--- /dev/null
+++ b/src/backend/access/transam/fdwxact_launcher.c
@@ -0,0 +1,587 @@
+/*-------------------------------------------------------------------------
+ *
+ * launcher.c
+ *
+ * The foreign transaction resolver launcher process starts foreign
+ * transaction resolver processes. The launcher schedules resolver
+ * process to be started when requested by backend process.
+ *
+ * Portions Copyright (c) 2021, PostgreSQL Global Development Group
+ *
+ * IDENTIFICATION
+ *	  src/backend/access/transam/fdwxact_launcher.c
+ *
+ *-------------------------------------------------------------------------
+ */
+
+#include "postgres.h"
+
+#include "funcapi.h"
+#include "pgstat.h"
+#include "funcapi.h"
+
+#include "access/fdwxact.h"
+#include "access/fdwxact_launcher.h"
+#include "access/fdwxact_resolver.h"
+#include "access/resolver_internal.h"
+#include "access/twophase.h"
+#include "commands/dbcommands.h"
+#include "funcapi.h"
+#include "postmaster/bgworker.h"
+#include "postmaster/interrupt.h"
+#include "storage/ipc.h"
+#include "storage/proc.h"
+#include "tcop/tcopprot.h"
+#include "utils/builtins.h"
+
+/* max sleep time between cycles (3min) */
+#define DEFAULT_NAPTIME_PER_CYCLE 180000L
+
+FdwXactResolver *MyFdwXactResolver = NULL;
+
+static volatile sig_atomic_t got_SIGUSR2 = false;
+
+static void FdwXactLauncherOnExit(int code, Datum arg);
+static void LaunchFdwXactResolver(Oid dbid, Oid serverid);
+static bool RelaunchFdwXactResolvers(void);
+static FdwXactResolver *FdwXactResolverFind(Oid dbid, Oid serverid);
+
+/* Signal handler */
+static void FdwXactLaunchHandler(SIGNAL_ARGS);
+
+
+/*
+ * Wake up the launcher process to request launching new resolvers
+ * immediately.
+ */
+void
+RequestToLaunchFdwXactResolver(void)
+{
+	if (FdwXactResolverCtl->launcher_pid != InvalidPid)
+		kill(FdwXactResolverCtl->launcher_pid, SIGUSR2);
+}
+
+/* Report shared memory space needed by FdwXactLauncherShmemInit */
+Size
+FdwXactLauncherShmemSize(void)
+{
+	Size		size = 0;
+
+	size = add_size(size, SizeOfFdwXactResolverCtlData);
+	size = add_size(size, mul_size(max_foreign_xact_resolvers,
+								   sizeof(FdwXactResolver)));
+
+	return size;
+}
+
+/*
+ * Allocate and initialize foreign transaction resolver shared
+ * memory.
+ */
+void
+FdwXactLauncherShmemInit(void)
+{
+	bool		found;
+
+	FdwXactResolverCtl = ShmemInitStruct("Foreign Transaction Launcher Data",
+										 FdwXactLauncherShmemSize(),
+										 &found);
+
+	if (!IsUnderPostmaster)
+	{
+		int			slot;
+
+		/* First time through, so initialize */
+		MemSet(FdwXactResolverCtl, 0, FdwXactLauncherShmemSize());
+		FdwXactResolverCtl->launcher_pid = InvalidPid;
+
+		for (slot = 0; slot < max_foreign_xact_resolvers; slot++)
+		{
+			FdwXactResolver *resolver = &FdwXactResolverCtl->resolvers[slot];
+
+			memset(resolver, 0, sizeof(FdwXactResolver));
+			SpinLockInit(&(resolver->mutex));
+		}
+	}
+}
+
+/*
+ * Cleanup function for fdwxact launcher
+ *
+ * Called on fdwxact launcher exit.
+ */
+static void
+FdwXactLauncherOnExit(int code, Datum arg)
+{
+	FdwXactResolverCtl->launcher_pid = InvalidPid;
+}
+
+/* SIGUSR2: set flag to launch new resolver process immediately */
+static void
+FdwXactLaunchHandler(SIGNAL_ARGS)
+{
+	int			save_errno = errno;
+
+	got_SIGUSR2 = true;
+	SetLatch(MyLatch);
+
+	errno = save_errno;
+}
+
+/*
+ * Main loop for the fdwxact launcher process.
+ */
+void
+FdwXactLauncherMain(Datum main_arg)
+{
+	TimestampTz last_start_time = 0;
+
+	ereport(DEBUG1,
+			(errmsg("fdwxact resolver launcher started")));
+
+	before_shmem_exit(FdwXactLauncherOnExit, (Datum) 0);
+
+	Assert(FdwXactResolverCtl->launcher_pid == InvalidPid);
+	FdwXactResolverCtl->launcher_pid = MyProcPid;
+	FdwXactResolverCtl->launcher_latch = &MyProc->procLatch;
+
+	pqsignal(SIGHUP, SignalHandlerForConfigReload);
+	pqsignal(SIGUSR2, FdwXactLaunchHandler);
+	pqsignal(SIGTERM, die);
+	BackgroundWorkerUnblockSignals();
+
+	BackgroundWorkerInitializeConnection(NULL, NULL, 0);
+
+	/* Enter main loop */
+	for (;;)
+	{
+		TimestampTz now;
+		long		wait_time = DEFAULT_NAPTIME_PER_CYCLE;
+		int			rc;
+
+		CHECK_FOR_INTERRUPTS();
+		ResetLatch(MyLatch);
+
+		now = GetCurrentTimestamp();
+
+		/*
+		 * Limit the start retry to once a
+		 * foreign_xact_resolution_retry_interval but always attempt to start
+		 * when requested.
+		 */
+		if (got_SIGUSR2 ||
+			TimestampDifferenceExceeds(last_start_time, now,
+									   foreign_xact_resolution_retry_interval))
+		{
+			MemoryContext oldctx;
+			MemoryContext subctx;
+			bool		launched;
+
+			if (got_SIGUSR2)
+				got_SIGUSR2 = false;
+
+			subctx = AllocSetContextCreate(TopMemoryContext,
+										   "Foreign Transaction Launcher",
+										   ALLOCSET_DEFAULT_SIZES);
+			oldctx = MemoryContextSwitchTo(subctx);
+
+			launched = RelaunchFdwXactResolvers();
+			if (launched)
+			{
+				last_start_time = now;
+				wait_time = foreign_xact_resolution_retry_interval;
+			}
+
+			/* Switch back to original memory context. */
+			MemoryContextSwitchTo(oldctx);
+
+			/* Clean the temporary memory. */
+			MemoryContextDelete(subctx);
+		}
+		else
+		{
+			/*
+			 * The wait in previous cycle was interrupted in less than
+			 * foreign_xact_resolution_retry_interval since last resolver
+			 * started, this usually means crash of the resolver, so we should
+			 * retry in foreign_xact_resolution_retry_interval again.
+			 */
+			wait_time = foreign_xact_resolution_retry_interval;
+		}
+
+		/* Wait for more work */
+		rc = WaitLatch(MyLatch,
+					   WL_LATCH_SET | WL_TIMEOUT | WL_POSTMASTER_DEATH,
+					   wait_time,
+					   WAIT_EVENT_FDWXACT_LAUNCHER_MAIN);
+
+		if (rc & WL_POSTMASTER_DEATH)
+			proc_exit(1);
+
+		if (rc & WL_LATCH_SET)
+		{
+			ResetLatch(MyLatch);
+			CHECK_FOR_INTERRUPTS();
+		}
+
+		if (ConfigReloadPending)
+		{
+			ConfigReloadPending = false;
+			ProcessConfigFile(PGC_SIGHUP);
+		}
+	}
+
+	/* Not reachable */
+}
+
+/*
+ * Request the launcher to launch or wakeup foreign transaction resolvers for
+ * the given servers.
+ */
+void
+LaunchOrWakeupFdwXactResolver(List *serveroids_orig)
+{
+	List	   *wakeup_resolvers = NIL;
+	List	   *serveroids = list_copy(serveroids_orig);
+
+	/* Collect running resolvers to wakeup */
+	LWLockAcquire(FdwXactResolverLock, LW_SHARED);
+	for (int i = 0;
+		 i < max_foreign_xact_resolvers && list_length(serveroids) > 0;
+		 i++)
+	{
+		FdwXactResolver *resolver = &FdwXactResolverCtl->resolvers[i];
+
+		if (resolver->in_use &&
+			resolver->dbid == MyDatabaseId &&
+			list_member_oid(serveroids, resolver->serverid))
+		{
+			wakeup_resolvers = lappend(wakeup_resolvers, resolver);
+			serveroids = list_delete_oid(serveroids, resolver->serverid);
+		}
+	}
+	LWLockRelease(FdwXactResolverLock);
+
+	if (wakeup_resolvers != NIL)
+	{
+		ListCell   *lc;
+
+		foreach(lc, wakeup_resolvers)
+		{
+			FdwXactResolver *resolver = (FdwXactResolver *) lfirst(lc);
+
+			/*
+			 * Wakeup the resolver. It's possible that the resolver is
+			 * starting up and doesn't attach its slot yet. Since the resolver
+			 * will find FdwXactState entry we inserted soon we don't
+			 * anything.
+			 */
+			if (resolver->latch)
+				SetLatch(resolver->latch);
+		}
+
+		list_free(wakeup_resolvers);
+	}
+
+	/* Request to launch new resolvers if any */
+	if (list_length(serveroids) > 0)
+		RequestToLaunchFdwXactResolver();
+}
+
+/*
+ * Launch a foreign transaction resolver process that will connect to given
+ * 'dbid' and 'serverid'.
+ */
+static void
+LaunchFdwXactResolver(Oid dbid, Oid serverid)
+{
+	BackgroundWorker bgw;
+	BackgroundWorkerHandle *bgw_handle;
+	FdwXactResolver *resolver;
+	int			unused_slot = -1;
+	int			i;
+
+	LWLockAcquire(FdwXactResolverLock, LW_EXCLUSIVE);
+
+	/* Find unused resolver slot */
+	for (i = 0; i < max_foreign_xact_resolvers; i++)
+	{
+		FdwXactResolver *resolver = &FdwXactResolverCtl->resolvers[i];
+
+		if (!resolver->in_use)
+		{
+			unused_slot = i;
+			break;
+		}
+	}
+
+	/* No unused found */
+	if (i >= max_foreign_xact_resolvers)
+		ereport(ERROR,
+				(errcode(ERRCODE_CONFIGURATION_LIMIT_EXCEEDED),
+				 errmsg("out of foreign transaction resolver slots"),
+				 errhint("You might need to increase max_foreign_transaction_resolvers.")));
+
+	resolver = &FdwXactResolverCtl->resolvers[unused_slot];
+	resolver->in_use = true;
+	resolver->dbid = dbid;
+	resolver->serverid = serverid;
+	LWLockRelease(FdwXactResolverLock);
+
+	/* Register the new dynamic worker */
+	memset(&bgw, 0, sizeof(bgw));
+	bgw.bgw_flags = BGWORKER_SHMEM_ACCESS |
+		BGWORKER_BACKEND_DATABASE_CONNECTION;
+	bgw.bgw_start_time = BgWorkerStart_RecoveryFinished;
+	snprintf(bgw.bgw_library_name, BGW_MAXLEN, "postgres");
+	snprintf(bgw.bgw_function_name, BGW_MAXLEN, "FdwXactResolverMain");
+	snprintf(bgw.bgw_name, BGW_MAXLEN,
+			 "foreign transaction resolver for server %u on database %u",
+			 resolver->serverid, resolver->dbid);
+	snprintf(bgw.bgw_type, BGW_MAXLEN, "foreign transaction resolver");
+	bgw.bgw_restart_time = BGW_NEVER_RESTART;
+	bgw.bgw_notify_pid = MyProcPid;
+	bgw.bgw_main_arg = Int32GetDatum(unused_slot);
+
+	if (!RegisterDynamicBackgroundWorker(&bgw, &bgw_handle))
+	{
+		/* Failed to launch, cleanup the worker slot */
+		SpinLockAcquire(&(MyFdwXactResolver->mutex));
+		resolver->in_use = false;
+		SpinLockRelease(&(MyFdwXactResolver->mutex));
+
+		ereport(WARNING,
+				(errcode(ERRCODE_CONFIGURATION_LIMIT_EXCEEDED),
+				 errmsg("out of background worker slots"),
+				 errhint("You might need to increase max_worker_processes.")));
+	}
+
+	/*
+	 * We don't need to wait until it attaches here because we're going to
+	 * wait until all foreign transactions are resolved.
+	 */
+}
+
+/*
+ * Check the pending foreign transaction entries and (re)launch the resolvers
+ * for them if necessary.  Return true if launched at least one resolver.
+ */
+static bool
+RelaunchFdwXactResolvers(void)
+{
+	HTAB	   *launch_resolvers;
+	HASHCTL		ctl;
+	HASH_SEQ_STATUS status;
+	struct fdwxact_resolver_entry
+	{
+		Oid			dbid;
+		Oid			serverid;
+	};
+	struct fdwxact_resolver_entry *entry;
+
+	/* Create a hash map for resolvers that need to launch */
+	memset(&ctl, 0, sizeof(ctl));
+	ctl.keysize = sizeof(struct fdwxact_resolver_entry);
+	ctl.entrysize = sizeof(struct fdwxact_resolver_entry);
+	launch_resolvers = hash_create("fdwxact resolvers to launch",
+								   32, &ctl, HASH_ELEM | HASH_BLOBS);
+
+	LWLockAcquire(FdwXactLock, LW_SHARED);
+	for (int i = 0; i < FdwXactCtl->num_xacts; i++)
+	{
+		FdwXactState fdwxact = FdwXactCtl->xacts[i];
+
+		if (!fdwxact->valid)
+			continue;
+
+		/*
+		 * We need to launch resolver process if the foreign transaction is
+		 * not held by anyone and is not a part of the local prepared
+		 * transaction.
+		 */
+		if (fdwxact->locking_backend == InvalidBackendId &&
+			!TwoPhaseExists(fdwxact->data.xid))
+		{
+			struct fdwxact_resolver_entry ent = {
+				.dbid = fdwxact->data.dbid,
+				.serverid = fdwxact->data.serverid
+			};
+
+			hash_search(launch_resolvers, (void *) &ent, HASH_ENTER, NULL);
+		}
+	}
+	LWLockRelease(FdwXactLock);
+
+	/* There is no foreign transaction to resolve, no need to launch new one */
+	if (hash_get_num_entries(launch_resolvers) == 0)
+	{
+		hash_destroy(launch_resolvers);
+		return false;
+	}
+
+	/* Check if the resolver is already running */
+	LWLockAcquire(FdwXactResolverLock, LW_SHARED);
+	for (int i = 0; i < max_foreign_xact_resolvers; i++)
+	{
+		FdwXactResolver *resolver = &FdwXactResolverCtl->resolvers[i];
+		struct fdwxact_resolver_entry ent;
+
+		if (!resolver->in_use)
+			continue;
+
+		ent.dbid = resolver->dbid;
+		ent.serverid = resolver->serverid;
+		hash_search(launch_resolvers, &ent, HASH_REMOVE, NULL);
+	}
+	LWLockRelease(FdwXactResolverLock);
+
+	/* Return if resolvers for all foreign transactions are already running */
+	if (hash_get_num_entries(launch_resolvers) == 0)
+	{
+		hash_destroy(launch_resolvers);
+		return false;
+	}
+
+	/* Launch new resolvers */
+	hash_seq_init(&status, launch_resolvers);
+	while ((entry = (struct fdwxact_resolver_entry *) hash_seq_search(&status)) != NULL)
+		LaunchFdwXactResolver(entry->dbid, entry->serverid);
+
+	hash_destroy(launch_resolvers);
+	return true;
+}
+
+/* Register a background worker running the foreign transaction launcher */
+void
+FdwXactLauncherRegister(void)
+{
+	BackgroundWorker bgw;
+
+	if (max_foreign_xact_resolvers == 0)
+		return;
+
+	memset(&bgw, 0, sizeof(bgw));
+	bgw.bgw_flags = BGWORKER_SHMEM_ACCESS |
+		BGWORKER_BACKEND_DATABASE_CONNECTION;
+	bgw.bgw_start_time = BgWorkerStart_RecoveryFinished;
+	snprintf(bgw.bgw_library_name, BGW_MAXLEN, "postgres");
+	snprintf(bgw.bgw_function_name, BGW_MAXLEN, "FdwXactLauncherMain");
+	snprintf(bgw.bgw_name, BGW_MAXLEN,
+			 "foreign transaction launcher");
+	snprintf(bgw.bgw_type, BGW_MAXLEN,
+			 "foreign transaction launcher");
+	bgw.bgw_restart_time = 5;
+	bgw.bgw_notify_pid = 0;
+	bgw.bgw_main_arg = (Datum) 0;
+
+	RegisterBackgroundWorker(&bgw);
+}
+
+bool
+IsFdwXactLauncher(void)
+{
+	return FdwXactResolverCtl->launcher_pid == MyProcPid;
+}
+
+/*
+ * Return the foreign transaction resolver running for dbid and serverid
+ */
+FdwXactResolver *
+FdwXactResolverFind(Oid dbid, Oid serverid)
+{
+	Assert(LWLockHeldByMe(FdwXactResolverLock));
+	for (int i = 0; i < max_foreign_xact_resolvers; i++)
+	{
+		FdwXactResolver *resolver = &FdwXactResolverCtl->resolvers[i];
+
+		if (resolver->in_use && resolver->dbid == dbid &&
+			resolver->serverid == serverid)
+			return resolver;
+	}
+
+	return NULL;
+}
+
+/*
+ * Stop the given foreign transaction resolver, and wait until it detaches
+ * from slot.
+ */
+void
+StopFdwXactResolver(Oid dbid, Oid serverid)
+{
+	FdwXactResolver *resolver;
+
+	LWLockAcquire(FdwXactResolverLock, LW_SHARED);
+
+	resolver = FdwXactResolverFind(dbid, serverid);
+
+	/* Not worker, nothing to do */
+	if (!resolver)
+	{
+		LWLockRelease(FdwXactResolverLock);
+		return;
+	}
+
+	/* Found the resolver, terminate it ... */
+	kill(resolver->pid, SIGTERM);
+
+	/* ... and wait for it to die */
+	for (;;)
+	{
+		int			rc;
+
+		/* is it gone? */
+		if (!resolver->in_use)
+			break;
+
+		LWLockRelease(FdwXactResolverLock);
+
+		/* Wait a bit --- we don't expect to have to wait long. */
+		rc = WaitLatch(MyLatch,
+					   WL_LATCH_SET | WL_TIMEOUT | WL_EXIT_ON_PM_DEATH,
+					   10L, WAIT_EVENT_BGWORKER_SHUTDOWN);
+
+		if (rc & WL_LATCH_SET)
+		{
+			ResetLatch(MyLatch);
+			CHECK_FOR_INTERRUPTS();
+		}
+
+		LWLockAcquire(FdwXactResolverLock, LW_SHARED);
+	}
+
+	LWLockRelease(FdwXactResolverLock);
+}
+
+/*
+ * Stop the fdwxact resolver running for the given foreign server.
+ */
+Datum
+pg_stop_foreign_xact_resolver(PG_FUNCTION_ARGS)
+{
+	char	   *servername = text_to_cstring(PG_GETARG_TEXT_P(0));
+	ForeignServer *server;
+	FdwXactResolver *resolver;
+
+	/* Must be super user */
+	if (!superuser())
+		ereport(ERROR,
+				(errcode(ERRCODE_INSUFFICIENT_PRIVILEGE),
+				 errmsg("permission denied to stop foreign transaction resolver")));
+
+	server = GetForeignServerByName(servername, false);
+
+	LWLockAcquire(FdwXactResolverLock, LW_SHARED);
+	resolver = FdwXactResolverFind(MyDatabaseId, server->serverid);
+	LWLockRelease(FdwXactResolverLock);
+
+	if (!resolver)
+		ereport(ERROR,
+				(errmsg("there is no running foreign transaction resolver process on server %s",
+						servername)));
+
+	StopFdwXactResolver(MyDatabaseId, server->serverid);
+	pfree(server);
+
+	PG_RETURN_BOOL(true);
+}
diff --git a/src/backend/access/transam/fdwxact_resolver.c b/src/backend/access/transam/fdwxact_resolver.c
new file mode 100644
index 0000000000..587c4759ca
--- /dev/null
+++ b/src/backend/access/transam/fdwxact_resolver.c
@@ -0,0 +1,339 @@
+/*-------------------------------------------------------------------------
+ *
+ * resolver.c
+ *
+ * The foreign transaction resolver background worker resolves in-doubt
+ * foreign transactions, foreign transactions participate to a distributed
+ * transaction but aren't being processed anyone.  A resolver process is
+ * launched per foreign server by foreign transaction launcher.
+ *
+ * Normal termination is by SIGTERM, which instructs the resolver process
+ * to exit(0) at the next convenient moment. Emergency termination is by
+ * SIGQUIT; like any backend. The resolver process also terminate by timeouts
+ * only if there is no pending foreign transactions on the database waiting
+ * to be resolved.
+ *
+ * Portions Copyright (c) 2021, PostgreSQL Global Development Group
+ *
+ * IDENTIFICATION
+ *	  src/backend/access/transam/fdwxact_resolver.c
+ *
+ *-------------------------------------------------------------------------
+ */
+
+#include "postgres.h"
+
+#include <signal.h>
+#include <unistd.h>
+
+#include "access/fdwxact.h"
+#include "access/fdwxact_resolver.h"
+#include "access/fdwxact_launcher.h"
+#include "access/resolver_internal.h"
+#include "access/transam.h"
+#include "access/twophase.h"
+#include "access/xact.h"
+#include "commands/dbcommands.h"
+#include "funcapi.h"
+#include "libpq/libpq.h"
+#include "miscadmin.h"
+#include "pgstat.h"
+#include "postmaster/bgworker.h"
+#include "postmaster/interrupt.h"
+#include "storage/ipc.h"
+#include "tcop/tcopprot.h"
+#include "utils/builtins.h"
+#include "utils/timeout.h"
+#include "utils/timestamp.h"
+
+/* max sleep time between cycles (3min) */
+#define DEFAULT_NAPTIME_PER_CYCLE 180000L
+
+/* GUC parameters */
+int			foreign_xact_resolution_retry_interval;
+int			foreign_xact_resolver_timeout = 60 * 1000;
+
+FdwXactResolverCtlData *FdwXactResolverCtl;
+
+static void FdwXactResolverLoop(void);
+static long FdwXactResolverComputeSleepTime(TimestampTz now);
+static void FdwXactResolverCheckTimeout(TimestampTz now);
+
+static void FdwXactResolverOnExit(int code, Datum arg);
+static void FdwXactResolverDetach(void);
+static void FdwXactResolverAttach(int slot);
+static void FdwXactResolverProcessInDoubtXacts(void);
+
+/* The list of currently holding FdwXact entries. */
+static List *heldFdwXactEntries = NIL;
+
+static TimestampTz last_resolution_time = -1;
+
+/*
+ * Detach the resolver and cleanup the resolver info.
+ */
+static void
+FdwXactResolverDetach(void)
+{
+	LWLockAcquire(FdwXactResolverLock, LW_EXCLUSIVE);
+
+	MyFdwXactResolver->pid = InvalidPid;
+	MyFdwXactResolver->in_use = false;
+	MyFdwXactResolver->dbid = InvalidOid;
+	MyFdwXactResolver->serverid = InvalidOid;
+
+	LWLockRelease(FdwXactResolverLock);
+
+	/*
+	 * Force to send remaining WAL statistics to the stats collector at
+	 * process exit.
+	 *
+	 * Since pgstat_send_wal is invoked with 'force' is false in main loop
+	 * to avoid overloading to the stats collector, there may exist unsent
+	 * stats counters for the WAL writer.
+	 */
+	pgstat_send_wal(true);
+}
+
+/*
+ * Cleanup up foreign transaction resolver info and releas the holding
+ * FdwXactState entries.
+ */
+static void
+FdwXactResolverOnExit(int code, Datum arg)
+{
+	ListCell   *lc;
+
+	FdwXactResolverDetach();
+
+	/* Release the held foreign transaction entries */
+	LWLockAcquire(FdwXactLock, LW_EXCLUSIVE);
+	foreach(lc, heldFdwXactEntries)
+	{
+		FdwXactState fdwxact = (FdwXactState) lfirst(lc);
+
+		if (fdwxact->valid && fdwxact->locking_backend == MyBackendId)
+			fdwxact->locking_backend = InvalidBackendId;
+	}
+	LWLockRelease(FdwXactLock);
+}
+
+/*
+ * Attach to a slot.
+ */
+static void
+FdwXactResolverAttach(int slot)
+{
+	/* Block concurrent access */
+	LWLockAcquire(FdwXactResolverLock, LW_EXCLUSIVE);
+
+	Assert(slot >= 0 && slot < max_foreign_xact_resolvers);
+	MyFdwXactResolver = &FdwXactResolverCtl->resolvers[slot];
+
+	if (!MyFdwXactResolver->in_use)
+	{
+		LWLockRelease(FdwXactResolverLock);
+		ereport(ERROR,
+				(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
+				 errmsg("foreign transaction resolver slot %d is empty, cannot attach",
+						slot)));
+	}
+
+	Assert(OidIsValid(MyFdwXactResolver->dbid));
+	Assert(OidIsValid(MyFdwXactResolver->serverid));
+
+	MyFdwXactResolver->pid = MyProcPid;
+	MyFdwXactResolver->latch = &MyProc->procLatch;
+
+	before_shmem_exit(FdwXactResolverOnExit, (Datum) 0);
+
+	LWLockRelease(FdwXactResolverLock);
+}
+
+/* Foreign transaction resolver entry point */
+void
+FdwXactResolverMain(Datum main_arg)
+{
+	int			slot = DatumGetInt32(main_arg);
+	char	   *datname;
+	ForeignServer *server;
+
+	/* Attach to a slot */
+	FdwXactResolverAttach(slot);
+
+	/* Establish signal handlers */
+	pqsignal(SIGHUP, SignalHandlerForConfigReload);
+	pqsignal(SIGTERM, die);
+	BackgroundWorkerUnblockSignals();
+
+	/* Connect to our database */
+	BackgroundWorkerInitializeConnectionByOid(MyFdwXactResolver->dbid, InvalidOid, 0);
+
+	StartTransactionCommand();
+	datname = get_database_name(MyFdwXactResolver->dbid);
+	server = GetForeignServer(MyFdwXactResolver->serverid);
+	ereport(LOG,
+			(errmsg("foreign transaction resolver for server \"%s\" on database \"%s\" has started",
+					server->servername, datname)));
+	pfree(datname);
+	pfree(server);
+	CommitTransactionCommand();
+
+	/* Initialize stats to a sanish value */
+	last_resolution_time = GetCurrentTimestamp();
+
+	/* Run the main loop */
+	FdwXactResolverLoop();
+
+	proc_exit(0);
+}
+
+/*
+ * Fdwxact resolver main loop
+ */
+static void
+FdwXactResolverLoop(void)
+{
+	/* Enter main loop */
+	for (;;)
+	{
+		TimestampTz now;
+		int			rc;
+		long		sleep_time = DEFAULT_NAPTIME_PER_CYCLE;
+
+		ResetLatch(MyLatch);
+
+		CHECK_FOR_INTERRUPTS();
+
+		if (ConfigReloadPending)
+		{
+			ConfigReloadPending = false;
+			ProcessConfigFile(PGC_SIGHUP);
+		}
+
+		/* Resolve in-doubt transactions if any  */
+		FdwXactResolverProcessInDoubtXacts();
+
+		now = GetCurrentTimestamp();
+		FdwXactResolverCheckTimeout(now);
+		sleep_time = FdwXactResolverComputeSleepTime(now);
+
+		/* Send WAL statistics to the stats collector */
+		pgstat_send_wal(false);
+
+		rc = WaitLatch(MyLatch,
+					   WL_LATCH_SET | WL_TIMEOUT | WL_POSTMASTER_DEATH,
+					   sleep_time,
+					   WAIT_EVENT_FDWXACT_RESOLVER_MAIN);
+
+		if (rc & WL_POSTMASTER_DEATH)
+			proc_exit(1);
+	}
+}
+
+/*
+ * Check whether there have been foreign transactions by the backend within
+ * foreign_xact_resolver_timeout and shutdown if not.
+ */
+static void
+FdwXactResolverCheckTimeout(TimestampTz now)
+{
+	TimestampTz timeout;
+	ForeignServer *server;
+
+	if (foreign_xact_resolver_timeout == 0)
+		return;
+
+	timeout = TimestampTzPlusMilliseconds(last_resolution_time,
+										  foreign_xact_resolver_timeout);
+
+	if (now < timeout)
+		return;
+
+	/* Reached timeout, exit */
+	StartTransactionCommand();
+	server = GetForeignServer(MyFdwXactResolver->serverid);
+	ereport(LOG,
+			(errmsg("foreign transaction resolver for server \"%s\" on database \"%s\" will stop because the timeout",
+					server->servername,
+					get_database_name(MyDatabaseId))));
+	CommitTransactionCommand();
+	FdwXactResolverDetach();
+	proc_exit(0);
+}
+
+/*
+ * Compute how long we should sleep by the next cycle. We can sleep until the time
+ * out.
+ */
+static long
+FdwXactResolverComputeSleepTime(TimestampTz now)
+{
+	long		sleeptime = DEFAULT_NAPTIME_PER_CYCLE;
+
+	if (foreign_xact_resolver_timeout > 0)
+	{
+		TimestampTz timeout;
+
+		/* Compute relative time until wakeup. */
+		timeout = TimestampTzPlusMilliseconds(last_resolution_time,
+											  foreign_xact_resolver_timeout);
+		sleeptime = TimestampDifferenceMilliseconds(now, timeout);
+	}
+
+	return sleeptime;
+}
+
+bool
+IsFdwXactResolver(void)
+{
+	return MyFdwXactResolver != NULL;
+}
+
+/*
+ * Process in-doubt foreign transactions.
+ */
+static void
+FdwXactResolverProcessInDoubtXacts(void)
+{
+	ListCell   *lc;
+
+	Assert(heldFdwXactEntries == NIL);
+
+	/* Hold all in-doubt foreign transactions */
+	LWLockAcquire(FdwXactLock, LW_EXCLUSIVE);
+	for (int i = 0; i < FdwXactCtl->num_xacts; i++)
+	{
+		FdwXactState fdwxact = FdwXactCtl->xacts[i];
+
+		if (fdwxact->valid &&
+			fdwxact->locking_backend == InvalidBackendId &&
+			fdwxact->data.dbid == MyFdwXactResolver->dbid &&
+			fdwxact->data.serverid == MyFdwXactResolver->serverid &&
+			!TwoPhaseExists(fdwxact->data.xid))
+		{
+			fdwxact->locking_backend = MyBackendId;
+			heldFdwXactEntries = lappend(heldFdwXactEntries, fdwxact);
+		}
+	}
+	LWLockRelease(FdwXactLock);
+
+	foreach(lc, heldFdwXactEntries)
+	{
+		FdwXactState fdwxact = (FdwXactState) lfirst(lc);
+
+		/*
+		 * Resolve one foreign transaction. ResolveOneFdwXact() releases and
+		 * removes FdwXactState entry after resolution.
+		 */
+		StartTransactionCommand();
+		ResolveOneFdwXact(fdwxact);
+		CommitTransactionCommand();
+	}
+
+	if (list_length(heldFdwXactEntries) > 0)
+		last_resolution_time = GetCurrentTimestamp();
+
+	list_free(heldFdwXactEntries);
+	heldFdwXactEntries = NIL;
+}
diff --git a/src/backend/access/transam/rmgr.c b/src/backend/access/transam/rmgr.c
index 58091f6b52..0a3f4b383f 100644
--- a/src/backend/access/transam/rmgr.c
+++ b/src/backend/access/transam/rmgr.c
@@ -10,6 +10,7 @@
 #include "access/brin_xlog.h"
 #include "access/clog.h"
 #include "access/commit_ts.h"
+#include "access/fdwxact_xlog.h"
 #include "access/generic_xlog.h"
 #include "access/ginxlog.h"
 #include "access/gistxlog.h"
diff --git a/src/backend/access/transam/twophase.c b/src/backend/access/transam/twophase.c
index f67d813c56..29980d56ac 100644
--- a/src/backend/access/transam/twophase.c
+++ b/src/backend/access/transam/twophase.c
@@ -77,6 +77,7 @@
 #include <unistd.h>
 
 #include "access/commit_ts.h"
+#include "access/fdwxact.h"
 #include "access/htup_details.h"
 #include "access/subtrans.h"
 #include "access/transam.h"
@@ -846,6 +847,34 @@ TwoPhaseGetGXact(TransactionId xid, bool lock_held)
 	return result;
 }
 
+/*
+ * TwoPhaseExists
+ *		Return true if there is a prepared transaction specified by XID
+ */
+bool
+TwoPhaseExists(TransactionId xid)
+{
+	int		i;
+	bool	found = false;
+
+	LWLockAcquire(TwoPhaseStateLock, LW_SHARED);
+
+	for (i = 0; i < TwoPhaseState->numPrepXacts; i++)
+	{
+		GlobalTransaction gxact = TwoPhaseState->prepXacts[i];
+
+		if (gxact->xid == xid)
+		{
+			found = true;
+			break;
+		}
+	}
+
+	LWLockRelease(TwoPhaseStateLock);
+
+	return found;
+}
+
 /*
  * TwoPhaseGetDummyBackendId
  *		Get the dummy backend ID for prepared transaction specified by XID
@@ -1556,6 +1585,12 @@ FinishPreparedTransaction(const char *gid, bool isCommit)
 	/* Count the prepared xact as committed or aborted */
 	AtEOXact_PgStat(isCommit, false);
 
+	/*
+	 * If the prepared transaction was a part of a distributed transaction
+	 * notify a resolver process to handle it.
+	 */
+	FdwXactLaunchResolversForXid(xid);
+
 	/*
 	 * And now we can clean up any files we may have left.
 	 */
diff --git a/src/backend/access/transam/xact.c b/src/backend/access/transam/xact.c
index 1e00a3a98e..d007c97c75 100644
--- a/src/backend/access/transam/xact.c
+++ b/src/backend/access/transam/xact.c
@@ -2131,7 +2131,7 @@ CommitTransaction(void)
 		AtEOXact_Parallel(true);
 
 	/* Call foreign transaction callbacks at pre-commit phase, if any */
-	AtEOXact_FdwXact(true, is_parallel_worker);
+	PreCommit_FdwXact(is_parallel_worker);
 
 	/* Shut down the deferred-trigger manager */
 	AfterTriggerEndXact(true);
@@ -2286,6 +2286,7 @@ CommitTransaction(void)
 	AtEOXact_PgStat(true, is_parallel_worker);
 	AtEOXact_Snapshot(true, false);
 	AtEOXact_ApplyLauncher(true);
+	AtEOXact_FdwXact(true, is_parallel_worker);
 	pgstat_report_xact_timestamp(0);
 
 	CurrentResourceOwner = NULL;
@@ -2559,6 +2560,7 @@ PrepareTransaction(void)
 	PostPrepare_Twophase();
 
 	/* PREPARE acts the same as COMMIT as far as GUC is concerned */
+	AtEOXact_FdwXact(true, false);
 	AtEOXact_GUC(true, 1);
 	AtEOXact_SPI(true);
 	AtEOXact_Enum();
diff --git a/src/backend/catalog/dependency.c b/src/backend/catalog/dependency.c
index 0c37fc1d53..b951c03d20 100644
--- a/src/backend/catalog/dependency.c
+++ b/src/backend/catalog/dependency.c
@@ -1470,6 +1470,10 @@ doDeletion(const ObjectAddress *object, int flags)
 			RemovePublicationRelById(object->objectId);
 			break;
 
+		case OCLASS_USER_MAPPING:
+			RemoveUserMappingById(object->objectId);
+			break;
+
 		case OCLASS_CAST:
 		case OCLASS_COLLATION:
 		case OCLASS_CONVERSION:
@@ -1485,7 +1489,6 @@ doDeletion(const ObjectAddress *object, int flags)
 		case OCLASS_TSTEMPLATE:
 		case OCLASS_FDW:
 		case OCLASS_FOREIGN_SERVER:
-		case OCLASS_USER_MAPPING:
 		case OCLASS_DEFACL:
 		case OCLASS_EVENT_TRIGGER:
 		case OCLASS_PUBLICATION:
diff --git a/src/backend/catalog/system_views.sql b/src/backend/catalog/system_views.sql
index 999d984068..f36f05f5cc 100644
--- a/src/backend/catalog/system_views.sql
+++ b/src/backend/catalog/system_views.sql
@@ -402,6 +402,9 @@ CREATE VIEW pg_prepared_xacts AS
 CREATE VIEW pg_prepared_statements AS
     SELECT * FROM pg_prepared_statement() AS P;
 
+CREATE VIEW pg_foreign_xacts AS
+    SELECT * FROM pg_foreign_xacts() AS F;
+
 CREATE VIEW pg_seclabels AS
 SELECT
     l.objoid, l.classoid, l.objsubid,
diff --git a/src/backend/commands/dbcommands.c b/src/backend/commands/dbcommands.c
index 2b159b60eb..25ad64639f 100644
--- a/src/backend/commands/dbcommands.c
+++ b/src/backend/commands/dbcommands.c
@@ -23,6 +23,7 @@
 #include <unistd.h>
 #include <sys/stat.h>
 
+#include "access/fdwxact.h"
 #include "access/genam.h"
 #include "access/heapam.h"
 #include "access/htup_details.h"
@@ -821,6 +822,7 @@ dropdb(const char *dbname, bool missing_ok, bool force)
 	int			nslots,
 				nslots_active;
 	int			nsubscriptions;
+	int			nfdwxacts;
 
 	/*
 	 * Look up the target database's OID, and get exclusive lock on it. We
@@ -910,6 +912,18 @@ dropdb(const char *dbname, bool missing_ok, bool force)
 								  "There are %d subscriptions.",
 								  nsubscriptions, nsubscriptions)));
 
+	/*
+	 * Also check if there is foreign transaction associated with the target
+	 * database.
+	 */
+	if ((nfdwxacts = CountFdwXactsForDB(db_id)) > 0)
+		ereport(ERROR,
+				(errcode(ERRCODE_OBJECT_IN_USE),
+				 errmsg("database \"%s\" is being used by foreign transaction resolution",
+						dbname),
+				 errdetail_plural("There is %d foreign transaction.",
+								  "There are %d foreign transactions.",
+								  nfdwxacts, nfdwxacts)));
 
 	/*
 	 * Attempt to terminate all existing connections to the target database if
